﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Diagnostics;

namespace ConfirmWaitAny
{
    class Program
    {
        // EventWaitHandle定義
        private static EventWaitHandle waitHandle1 = null;
        private static EventWaitHandle waitHandle2 = null;

        // 時間をはかるためにストップウォッチを定義
        private static Stopwatch watch = null;

        static void Main(string[] args)
        {
            // EventWaitHandle生成
            waitHandle1 = new EventWaitHandle(false, EventResetMode.ManualReset);
            waitHandle2 = new EventWaitHandle(false, EventResetMode.ManualReset);

            // Stopwatch生成
            watch = new Stopwatch();

            // Thread生成
            Thread thread = new Thread(run);
            // Threadスタート
            thread.Start();
            // Stopwatchスタート
            watch.Start();

            while (true)
            {
                if (watch.ElapsedMilliseconds == 2001)
                {
                    // waitHandle1をシグナル状態にする
                    waitHandle1.Set();
                }
                else if (watch.ElapsedMilliseconds == 5001)
                {
                    // waitHandle1を非シグナル状態にする
                    waitHandle1.Reset();
                }
                else if (watch.ElapsedMilliseconds == 7001)
                {
                    // waitHandle2をシグナル状態にする
                    waitHandle2.Set();
                }
                else if (watch.ElapsedMilliseconds == 9001)
                {
                    // waitHandle2を非シグナル状態にする
                    waitHandle2.Reset();
                }
                else if (watch.ElapsedMilliseconds > 10000)
                {
                    // thread、Stopwatchストップ
                    thread.Abort();
                    watch.Stop();
                    break;
                }
            }
        }

        private static void run()
        {
            while (true)
            {
                // 1秒に1度出力
                if (watch.ElapsedMilliseconds % 1000 == 0)
                {
                    WaitHandle[] handleArray = new WaitHandle[] { waitHandle1, waitHandle2 };
                    int waitIndex = WaitHandle.WaitAny(handleArray);
                    Debug.WriteLine("待機インデックス：" + waitIndex + "、経過時間：" + watch.ElapsedMilliseconds);
                }
            }
        }
    }
}
